# EventScripts Minecraft Example
# Copyright 2011, Mattie Casper
#
# magichelmet.py
#   Allow underwater breathing
#
import esm
from esm import items
import magicitems
import time

class MagicHelmet():
    def __init__(self, cfg):
        self.helmetplayers = {}
        self.cooldowns = {}
        self.seatouchenabled = cfg.getBoolean("magichelmet-seatouch-enabled", True)
        self.seatouchcost = cfg.getInt("magichelmet-seatouch-cost", 3)
        self.cost = cfg.getInt("magichelmet-merminer-costperbreath", 1)
        self.breath = cfg.getInt("magichelmet-merminer-breathseconds", 30)

    def useSeatouch(self, player, block):
        if self.seatouchenabled:
            if magicitems.spendRedstone(player, self.seatouchcost):
                bl = block.getRelative(0, 1, 0)
                if bl.getTypeId() == items.air:
                    bl.setTypeId(items.water)
        return True

    def useWaterBreathing(self, player):
        if magicitems.isPlayerWearing(player, items.goldhelmet):
            if magicitems.spendRedstone(player, self.cost):
                player.remainingair = player.maximumair
                return False
        # no helmet or no stone and you're out of luck!
        return True

    def checkAnyAirTimeLeft(self, player):
        name = player.getName()
        if name in self.helmetplayers:
            now = time.time()
            if now > self.helmetplayers[name] + self.breath:
                return False
            else:
                return True
        return False
