# EventScripts Minecraft Example
# Copyright 2011, Mattie Casper
#
# magicitems.py
#   Magic items to make gold and redstone more useful day-to-day
#  
# Version: 0.3

import esm
from esm import items
import esm.blocklib as blocklib
import com.eventscripts.minecraft.PropertiesFile as PropertiesFile
from org.bukkit.event.entity import EntityDamageByEntityEvent

import magichelmet
reload(magichelmet)
#import magicpick
#reload(magicpick)
import magicshovel
reload(magicshovel)
import magicwatch
reload(magicwatch)
import magicblocks
reload(magicblocks)
import magicsword
reload(magicsword)
import magicrod
reload(magicrod)

from utils import *
import java.util.LinkedHashSet as LinkedHashSet

helmet = None
pick = None
shovel = None
watch = None
warp = None
cfg = None
sword = None
rod = None

def load():
    global cfg, helmet, pick, shovel, watch, warp, sword, rod
    cfg = PropertiesFile("magicitems.properties")
    if cfg.getBoolean("magichelmet-enabled", True):
        helmet = magichelmet.MagicHelmet(cfg)
    if cfg.getBoolean("magicpick-enabled", False):
        pick = magicpick.MagicPick(cfg)
    if cfg.getBoolean("magicshovel-enabled", True):
        shovel = magicshovel.MagicShovel(cfg)
    if cfg.getBoolean("magicwatch-enabled", True):
        watch = magicwatch.MagicWatch(cfg)
    if cfg.getBoolean("magicblocks-enabled", True):
        warp = magicblocks.MagicBlocks(cfg)
    if cfg.getBoolean("magicsword-enabled", True):
        sword = magicsword.MagicSword(cfg)
    if cfg.getBoolean("magicrod-enabled", True):
        rod = magicrod.MagicRod(cfg)
    esm.output("[MagicItems] Loaded.")

# TODO: Allow disabling of individual magic items
# List of events and how those tie into all the magic items

def block_break(event):
    inhand = event.player.iteminhand.typeid
    if shovel and inhand == items.goldspade:
        return shovel.useMagicShovel(event.player, event.block)
    if watch and inhand == items.watch:
        if event.block.typeid == items.stone:
            return watch.useDaybreak(event.player, event.block)
    if warp and inhand == items.compass:
        if event.block.typeid == items.goldblock:
            return warp.useBasecamp(event.player, event.block)
    if sword and inhand == items.goldsword:
        if event.block.typeid == items.mobspawner:
            sword.useSwordsToPlowshares(event.player, event.block)
    return True

def block_damage(event):
    if warp and event.player.iteminhand.typeid == items.redstone:
        return warp.useWarpBind(event.player, event.block)
    if pick and event.player.iteminhand.typeid == items.goldpickaxe:
        return pick.useResourceScan(event.player, event.block)
    return not pick.checkProtectedBlock(event.block) if pick else True

import time
chestitems = {}
picooldown = {}
def player_interact(event):
    # check for any right-click event
    if event.item and event.action.name()[0:5] == "RIGHT":
        # This fires so frequently, let's use ~2sec cooldown to avoid multiple fires
        name = event.player.displayname
        if name in picooldown:
            if picooldown[name] >= time.time() - 1:
                return True
        picooldown[name] = time.time()
        if warp and event.item.typeid == items.compass:
            return warp.useBasequick(event.player)
        if helmet and event.item.typeid == items.goldhelmet and event.clickedblock:
            return helmet.useSeatouch(event.player, event.clickedblock)
        if rod and event.item.typeid == items.fishingrod and event.clickedblock:
            return rod.useFishingTrip(event.player, event.clickedblock)
        if event.item.typeid == items.goldchestplate and event.clickedblock:
            pass
    return True

def entity_damage(event):
    if esm.isInstance(event, EntityDamageByEntityEvent):
        attacker = event.damager
        if sword and attacker and esm.isPlayer(attacker) and str(event.cause) == "ENTITY_ATTACK" and attacker.iteminhand.typeid == items.goldsword:
            return sword.useSunslice(attacker, event.entity)
    if helmet and esm.isPlayer(event.entity):
        if event.getCause() == event.DamageCause.DROWNING:
            return helmet.useWaterBreathing(event.entity)
    return True

def player_join(event):
    if warp:
        warp.trackPlayer(event.player)

def player_move(event):
    # check for jumps
    if warp:
        if not warp.useBasejump(event.player, event.from, event.to):
            event.from = event.player.getLocation()
            return False
    return True
    # disabled redcrumbs since beta
    # pants.useRedcrumbs(event.player, event.from)



#def chunk_loaded(event):
#    esm.output(event)