# EventScripts Minecraft Example
# Copyright 2011, Mattie Casper
#
# magicshovel.py
#   Allows rapid mining of gravel and sand
#
import esm
from esm import items
import magicitems
import time
from org.bukkit.inventory import ItemStack


class MagicShovel():
    def __init__(self, cfg):
        self.players = {}
        self.cost = cfg.getInt("magicshovel-undermine-cost-per-activation", 2)
        self.length = cfg.getInt("magicshovel-undermine-activation-seconds", 10)

    def useMagicShovel(self, player, tblock):
        if (tblock.getTypeId() in (esm.items.gravel, esm.items.sand, esm.items.dirt)):
            # loop upwards and kill gravel or sand above
            block = tblock.getRelative(0, 1, 0)
            while block.getTypeId() == tblock.getTypeId():
                if not self.checkAnyShovelTimeLeft(player):
                    if magicitems.spendRedstone(player, self.cost):
                        self.players[player.getName()] = time.time()
                    else:
                        return True
                block.setTypeId(esm.items.air)
                esm.world.dropItemNaturally(block.getLocation(), ItemStack(tblock.getTypeId(), 1))
                block = block.getRelative(0, 1, 0)
        return True

    def checkAnyShovelTimeLeft(self, player):
        name = player.getName()
        if name in self.players:
            now = time.time()
            if now > self.players[name] + self.length:
                return False
            else:
                return True
        return False

