# EventScripts Minecraft Example
# Copyright 2011, Mattie Casper
#
# magicsword.py
#   Your sword can burn+spin mobs and also die to repair your stuff
#

import esm
from esm import items
import esm.blocklib
import magicitems
from org.bukkit.inventory import ItemStack

class MagicSword():
    def __init__(self, cfg):
        pre = "magicsword-"
        # defaults
        self.sunsliceenabled = cfg.getBoolean(pre+"sunslice-enabled", True)
        self.redstonecost = cfg.getInt(pre+"sunslice-redstonecost", 1)
        self.stpenabled = cfg.getBoolean(pre+"swordstoplowshares-enabled", True)
    def useSunslice(self, player, mob):
        if self.sunsliceenabled and magicitems.spendRedstone(player, self.redstonecost):
            mob.getHandle().fireTicks = 120
            mobl = mob.location
            playl = player.location
            mob.teleportTo(esm.location(mobl.x, mobl.y, mobl.z, playl.yaw, playl.pitch, playl.getWorld()))
        return True
    def useSwordsToPlowshares(self, player, block):
        if self.stpenabled:
            def explode(x, y, z, world):
                bl = esm.blockat(x, y, z, world)
                esm.blocklib.experimental.explode(bl, 1.0)
            esm.queue(explode, (block.getX(), block.getY(), block.getZ(), block.getWorld()))
            _repairBySword(player)
            return True
        return True


def _repairBySword(player):
    inv = player.inventory
    esm.output(inv.size)
    for i in range(0, inv.size):
        it = inv.getItem(i)
        esm.output(str(it.getTypeId()) + " " + str(it.getDurability()))
        id = it.getTypeId()
        if id != esm.items.goldsword:
            if it.getDurability() > 0:
                newit = ItemStack(id, 1)
                inv.setItem(i, newit)
                esm.output("fixing:" + str(it.getTypeId()) + " " + str(it.getDurability()))
    boots = inv.boots
    boots.durability = 0
    inv.boots = boots.getTrueInternalObject()
    helmet = inv.helmet
    helmet.durability = 0
    inv.helmet = helmet.getTrueInternalObject()
    chestplate = inv.chestplate
    chestplate.durability = 0
    inv.chestplate = chestplate.getTrueInternalObject()
    leggings = inv.leggings
    leggings.durability = 0
    inv.leggings = leggings.getTrueInternalObject()
    inv.clear(inv.getHeldItemSlot())
