# EventScripts Minecraft Example
# Copyright 2011, Mattie Casper
#
# magicwatch.py
#   Your watch can control time if you destroy it.
#

import esm
from esm import items
import esm.blocklib

class MagicWatch():
    def __init__(self, cfg):
        self.daybreaktime = cfg.getInt("magicwatch-daybreak-time", 23400)
        self.daybreakradius = cfg.getDouble("magicwatch-daybreak-explosion-radius", 1.0)
    def useDaybreak(self, player, block):
        def explode(x, y, z, world):
            bl = esm.blockat(x, y, z, world)
            esm.blocklib.experimental.explode(bl, self.daybreakradius)
        esm.queue(explode, (block.getX(), block.getY(), block.getZ(), block.getWorld()))
        player.world.time = self.daybreaktime
        inv = player.getInventory()
        item = inv.getItemInHand()
        amount = item.getAmount()
        if amount > 1:
            item.setAmount(amount-1)
            inv.setItem(inv.getHeldItemSlot(), item)
        else:
            inv.clear(inv.getHeldItemSlot())
        return True