# EventScripts Minecraft Example
# Copyright 2011, Mattie Casper
#
# utils.py
#   Some tools to help with magic items
#

import esm
from esm import items
import org.bukkit.entity.Item as Item

def totalItems(inv, itemid):
    total = 0
    # loop through all items that match the itemid and sum up
    for entry in inv.all(itemid).entrySet():
        total += entry.value.getAmount()
    return total

import org.bukkit.inventory.ItemStack as ItemStack
from jarray import *

def removeItemCount(inv, itemid, count):
#    inv.removeItem(array([ItemStack(itemid, count)], ItemStack))
    for entry in inv.all(itemid).entrySet():
        slot = entry.key
        item = entry.value
        amount = item.getAmount()
        if count > amount:
            count -= amount
            inv.clear(slot)
        else:
            newitem = ItemStack(item.getTypeId(), amount-count)
            inv.setItem(slot, newitem)
            return

def isPlayerWearing(player, item):
    eq = player.getInventory().getArmorContents()
    for i in eq:
        if i.getTypeId() == item:
           return True
    return False

def isRedstoneCostAvailable(player, cost, inv=None):
    if inv == None:
        inv = player.getInventory()
    if inv and totalItems(inv, esm.items.redstone) >= cost:
        return True
    else:
        return False

def spendRedstone(player, cost, inv=None):
    if inv == None:
        inv = player.getInventory()
    if isRedstoneCostAvailable(player, cost, inv):
        removeItemCount(inv, items.redstonedust, cost)
        return True
    else:
        return False
